/**
/** Comparative Genomics workflow
/**
/** This workflow find the duplicate genes from a proteome
/** Then, It finds the Tandemly Arrayed Genes (TAGs)
/**/

nextflow.enable.dsl = 2;

include { GUNZIP } from "./modules/gunzip.nf"
include { BLAST_MAKEBLASTDB } from "./modules/blast.nf"
include { BLAST_BLASTP } from "./modules/blast.nf"
include { FILTER_FASTA } from "./modules/filter_fasta.nf"
include { FILTER_BLASTP } from "./modules/filter_blastp.nf"
include { CLUSTERING } from "./modules/clustering.nf"

workflow {
    proteome = Channel.fromPath(params.proteome)
    GUNZIP(proteome)
    FILTER_FASTA(GUNZIP.out)
    BLAST_MAKEBLASTDB(params.species, FILTER_FASTA.out.proteome)
    BLAST_BLASTP(params.species, FILTER_FASTA.out.proteome, BLAST_MAKEBLASTDB.out)
    FILTER_BLASTP(BLAST_BLASTP.out, FILTER_FASTA.out.protein_length)
    CLUSTERING(FILTER_BLASTP.out)
}
